#ifndef _MUNIX_ASSEMBLER_H
#define	_MUNIX_ASSEMBLER_H
/*******************************************************************************
 ** Name: assembler.h                                                         **
 ** Description:                                                              **
 **                                                                           **
 ** Open Source Initiative (OSI) Approved License                             **
 **                                                                           **
 ** The contents of this file are subject to the terms of the                 **
 ** Common Development and Distribution License, Version 1.0 only             **
 ** (the "License").  You may not use this file except in compliance          **
 ** with the License.                                                         **
 **                                                                           **
 ** You can find a copy of the license in the license.txt within              **
 ** this distribution or at http://www.munixos.net/licensing.                 **
 ** Software distributed under the License is distributed on an "AS IS"       **
 ** basis, WITHOUT WARRANTY OF ANY KIND, either express or implied.           **
 ** See the License for the specific language governing permissions           **
 ** and limitations under the License.                                        **
 **                                                                           **
 ** When distributing Covered Code, include this CDDL header in each          **
 ** file and include the License file at $HOME/license.txt.                   **
 ** If applicable, add the following below this header, with the indicated    **
 ** fields enclosed by brackets "[]" replaced with your own identifying       **
 ** information: Portions Copyright [yyyy] [name of copyright owner]          **
 **                                                                           **
 **                                                                           **
 ** Copyright (c) 2009-2010  Barry Gian James.                                **
 ** All rights reserved.                                                      **
 **                                                                           **
 ** Ref: $URL: https://DroidEngineer@munix.svn.codeplex.com/svn/trunk/asmu/assembler.h $
 ******************************************************************************/
// $Id: assembler.h 56176 2011-03-03 03:40:53Z unknown $
#include "opcodes.h"
#include "machine.h"

class Assembler
{
public:
    Assembler(const char *, MachineEmulator *);
    virtual ~Assembler();

    bool    Assemble(u32&,u16&);

private:
    void    _readint(char &,int &,bool &);
    void    _readmnemonic(char &, char *);
    void    _error(const char *,u32,bool&);
    void    _skiplabel(char &);

    FILE *              src;
    MachineEmulator *   emu;
};

#endif	/* _MUNIX_ASSEMBLER_H */

