/******************************************************************************
** Name: boot.S                                                              **
** Description: The ATBIOS boot file.                                        **
**                                                                           **
** Open Source Initiative (OSI) Approved License                             **
**                                                                           **
**  Copyright (c) 2009-2010 Barry "Gian" James  <bjames@munixos.net>         **
**  All rights reserved.                                                     **
**                                                                           **
**  Redistribution and use in source and binary forms, with or without       **
**  modification, are permitted provided that the following conditions are   **
**  met:                                                                     **
**                                                                           **
**  * Redistributions of source code must retain the above copyright notice, **
**    this list of conditions and the following disclaimer.                  **
**  * Redistributions in binary form must reproduce the above copyright      **
**    notice, this list of conditions and the following disclaimer in the    **
**    documentation and/or other materials provided with the distribution.   **
**                                                                           **
**  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS      **
** "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED **
** TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A           **
** PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT        **
** HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,    **
** SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED  **
** TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR    **
** PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF    **
** LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING      **
** NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS        **
** SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.              **
**                                                                           **
******************************************************************************/
#define _MUNIX_ATBIOSMAIN_H_ "$Id: boot.S 55956 2011-02-25 09:08:34Z unknown $"
// Last Modified $DateTime: 2010/02/12 01:42:30 $ by $Author: unknown $

.nolist
#include <avr/io.h>
.list

#define BAUDRATE        9600
#define UBRR_20_9600    129
#define USARTChar       r18


prompt:     .ascii "cmd:> "

.org 0000
Main:
    rjmp USART_Init

Loop:
    sleep
    nop
    jmp Loop


USART_Init:
    ldi r17, (UBRR_20_9600 << 8)
    ldi r16, UBRR_20_9600
    out UBRR0H, r17
    out UBRR0L, r16
    ldi r16, ((1<<RXEN0)|(1<<TXEN0))
    out UCSR0B, r16
    ret
USART_tx:
    sbis UCSR0A, UDRE0
    rjmp USART_tx
    out  UDR0, USARTChar
    ret
USART_rx:
    sbis  UCSR0A, RXC0
    rjmp  USART_rx
    in    USARTChar, UDR0
    ret

