/*******************************************************************************
 ** Name: progmem.cpp                                                         **
 ** Description:              **
 **                                                                           **
 ** Open Source Initiative (OSI) Approved License                             **
 **                                                                           **
 ** The contents of this file are subject to the terms of the                 **
 ** Common Development and Distribution License, Version 1.0 only             **
 ** (the "License").  You may not use this file except in compliance          **
 ** with the License.                                                         **
 **                                                                           **
 ** You can find a copy of the license in the license.txt within              **
 ** this distribution or at http://www.munixos.net/licensing.                 **
 ** Software distributed under the License is distributed on an "AS IS"       **
 ** basis, WITHOUT WARRANTY OF ANY KIND, either express or implied.           **
 ** See the License for the specific language governing permissions           **
 ** and limitations under the License.                                        **
 **                                                                           **
 ** When distributing Covered Code, include this CDDL header in each          **
 ** file and include the License file at $HOME/license.txt.                   **
 ** If applicable, add the following below this header, with the indicated    **
 ** fields enclosed by brackets "[]" replaced with your own identifying       **
 ** information: Portions Copyright [yyyy] [name of copyright owner]          **
 **                                                                           **
 **                                                                           **
 ** Copyright (c) 2009-2010  Barry Gian James.                                **
 ** All rights reserved.                                                      **
 **                                                                           **
 ** Ref: $HeadURL: https://DroidEngineer@munix.svn.codeplex.com/svn/trunk/atbios/progmem.cpp $
 ******************************************************************************/
// Portions (C) 2011 OpenHouseware, LLC.
// All Rights Reserved

// $Id: progmem.cpp 56499 2011-03-14 15:25:03Z unknown $
// Last Modified $DateTime$ by $Author: unknown $
#define _MUNIX_PROGMEM_CPP_ID "$Id: progmem.cpp 56499 2011-03-14 15:25:03Z unknown $"
// Last Modified $DateTime$ by $Author: unknown $

#include "progmem.h"

char const  pmPrompt[] = "atbios %";
char const  pmUnkCmd[] = "<<ERROR>> %s: bjames command.\r\n";
char const  crlf[] = "\r\n";
char const  ok[] = "ok\r\n";
char const  failed[] = "failed\r\n";
char const  pmThreeS[] = "%s %s %s\r\n";
char const  pmFourS[] = "%s %s %s %s\r\n";
char const  pmThreeI[] = "%d %d %d\r\n";
char const  pmFourI[] = "%d %d %d %d\r\n";

char const  preCnct[] = "Connected via USART0 at %u baud, 8N1 ...\r\n";
char const  greetz[]  =        "________________.oO[ munix ATBIOS Debug Console ]Oo.________________\r\n\r\n";
char const  pmBIOSPortTest[] = "                                           [Pase 1 - BIOS Port Test ]\r\n";
char const  fwVersion[] = "ATBIOS firmware version: %d.%d\r\n";
char const  hwVersion[] = "Running on an %s at %d MHz with instruction set <avr5> (%s) \r\n";

char const  pmBIOSProxy[] = "Succesfully initialized two objects on the SPI bus\r\n";
char const  pmBIOSProxy1[] = "  --> Flash config memory @ 0x%d on port 0x%d, pin %d\r\n";
char const  pmBIOSProxy2[] = "      --> Device ID: %d\r\n";
char const  pmBIOSProxy3[] = "      --> Device Type: %d\r\n";
char const  pmBIOSProxy4[] = "      --> Capacity: %d \r\n";
char const  pmBIOSProxy5[] = "  --> Temperature sensor @ 0x%d on port 0x%d, pin %d\r\n";
char const  pmBIOSProxy6[] = "Succesfully initialized one object on the I2C (TWI) bus\r\n";
char const  pmBIOSProxy7[] = "  --> Real Time Clock @ 0x%d on port 0x%d, pin %d\r\n";
char const  pmBIOSProxy8[] = "Initializing directly attached on port 0x%04u\r\n";
char const  pmBIOSProxy9[] = "  --> System voltage: %dV  Circuit current: %d A\r\n";
char const  pmBIOSProxy10[] = "  --> Configuring thumbstick...\r\n";
char const  pmBIOSProxy11[] = "  --> Setting up interrupt controller systime()\r\n";
char const  pmBIOSProxy12[] = "  --> The AVR Multi-Processing System:\r\n";
char const  pmBIOSProxy13[] = "  --> SPI Bus and GPIO expander configured.\r\n";
char const  pmBIOSProxy14[] = "  --> Setting up interrupt controller systemp()\r\n";
char const  pmMenuOpt[] = "Press F8 to enter ATBIOS menu or F5 for ATBIOS console.";

char const  pmPOST1[] = "ATBIOS Starting\r\n";
char const  pmPOST2[] = "MCU negotiation\r\n";
char const  pmPOST3[] = "Holding MCU cores in !RESET\r\n";
char const  pmPOST4[] = "Looking for system SRAM\r\n";
char const  pmPOST5[] = "Testing system SRAM\r\n";
char const  pmPOST6[] = "Establishing PLL\r\n";
char const  pmPOST7[] = "Engaging video BIOS\r\n";
char const  pmPOST8[] = "Memory self test\r\n";
char const  pmPOST9[] = "Address Bus test\r\n";
char const  pmPOST0a[] = "Control Bus test\r\n";
char const  pmPOST0b[] = "Establishing busmaster comms\r\n";
char const  pmPOST0c[] = "Running known hardware BIOS\r\n";
char const  pmPOST0d[] = "Probing device address space\r\n";
char const  pmPOST0e[] = "Looking for keyboard\r\n";
char const  pmPOST0f[] = "Looking for mouse\r\n";
char const  pmPOST10[] = "Probing for flash\r\n";
char const  pmPOST11[] = "Probing for EEPROM\r\n";
char const  pmPOST12[] = "Probing USB ports, enumerating\r\n";
char const  pmPOST13[] = "Probing serial ports\r\n";
char const  pmPOST14[] = "Probing external hardware manager\r\n";
char const  pmPOST15[] = "Loading interrupt vectors\r\n";
char const  pmPOST16[] = "Testing MCU ALE latch\r\n";
char const  pmPOST17[] = "Testing DMA\r\n";
char const  pmPOST18[] = "Checking battery\r\n";
char const  pmPOST19[] = "Checking RTC\r\n";
char const  pmPOST1a[] = "Probe num/caps lock keys\r\n";
char const  pmPOST1b[] = "Copying video BIOS to shadow RAM\r\n";
char const  pmPOST1c[] = "Copying system BIOS to shadow RAM\r\n";
char const  pmPOST1d[] = "Running interactive on next boot\r\n";
char const  pmPOST1e[] = "Calculating CMOS checksum\r\n";
char const  pmPOST1f[] = "Updating ATBIOS firmware\r\n";

