#ifndef _MUNIX_PROGMEM_H_
#define	_MUNIX_PROGMEM_H_
/*******************************************************************************
 ** Name: progmem.h                                                             **
 ** Description:              **
 **                                                                           **
 ** Open Source Initiative (OSI) Approved License                             **
 **                                                                           **
 ** The contents of this file are subject to the terms of the                 **
 ** Common Development and Distribution License, Version 1.0 only             **
 ** (the "License").  You may not use this file except in compliance          **
 ** with the License.                                                         **
 **                                                                           **
 ** You can find a copy of the license in the license.txt within              **
 ** this distribution or at http://www.munixos.net/licensing.                 **
 ** Software distributed under the License is distributed on an "AS IS"       **
 ** basis, WITHOUT WARRANTY OF ANY KIND, either express or implied.           **
 ** See the License for the specific language governing permissions           **
 ** and limitations under the License.                                        **
 **                                                                           **
 ** When distributing Covered Code, include this CDDL header in each          **
 ** file and include the License file at $HOME/license.txt.                   **
 ** If applicable, add the following below this header, with the indicated    **
 ** fields enclosed by brackets "[]" replaced with your own identifying       **
 ** information: Portions Copyright [yyyy] [name of copyright owner]          **
 **                                                                           **
 **                                                                           **
 ** Copyright (c) 2009-2010  Barry Gian James.                                **
 ** All rights reserved.                                                      **
 **                                                                           **
 ** Ref: $HeadURL: https://DroidEngineer@munix.svn.codeplex.com/svn/trunk/atbios/progmem.h $
 ******************************************************************************/
// Portions (C) 2011 OpenHouseware, LLC.
// All Rights Reserved

// $Id: progmem.h 56282 2011-03-05 22:38:01Z unknown $
// Last Modified $DateTime$ by $Author: unknown $
#define _MUNIX_PROGMEM_H_ID "$Id: progmem.h 56282 2011-03-05 22:38:01Z unknown $"
// Last Modified $DateTime$ by $Author: unknown $

#include <avr/pgmspace.h>

// This is a sad state of affairs, but program space in C++ is broken and without
// this workaround compiling emitts tons of warnings. Well-known bug.

extern char const __attribute__((__progmem__))  pmPrompt[];
extern char const __attribute__((__progmem__))  pmUnkCmd[];
extern char const __attribute__((__progmem__))  crlf[];
extern char const __attribute__((__progmem__))  fwVersion[];
extern char const __attribute__((__progmem__))  hwVersion[];
extern char const __attribute__((__progmem__))  ok[];
extern char const __attribute__((__progmem__))  pmThreeS[];
extern char const __attribute__((__progmem__))  pmThreeI[];
extern char const __attribute__((__progmem__))  pmFourS[];
extern char const __attribute__((__progmem__))  pmFourI[];
extern char const __attribute__((__progmem__))  failed[];
extern char const __attribute__((__progmem__)) preCnct[];
extern char const __attribute__((__progmem__)) pmMenuOpt[];
extern char const __attribute__((__progmem__)) pmBIOSPortTest[];
extern char const __attribute__((__progmem__)) pmBIOSProxy[];
extern char const __attribute__((__progmem__)) pmBIOSProxy1[];
extern char const __attribute__((__progmem__)) pmBIOSProxy2[];
extern char const __attribute__((__progmem__)) pmBIOSProxy3[];
extern char const __attribute__((__progmem__)) pmBIOSProxy4[];
extern char const __attribute__((__progmem__)) pmBIOSProxy5[];
extern char const __attribute__((__progmem__)) pmBIOSProxy6[];
extern char const __attribute__((__progmem__)) pmBIOSProxy7[];
extern char const __attribute__((__progmem__)) pmBIOSProxy8[];
extern char const __attribute__((__progmem__)) pmBIOSProxy9[];
extern char const __attribute__((__progmem__)) pmBIOSProxy10[];
extern char const __attribute__((__progmem__)) pmBIOSProxy11[];
extern char const __attribute__((__progmem__)) pmBIOSProxy12[];
extern char const __attribute__((__progmem__)) pmBIOSProxy13[];
extern char const __attribute__((__progmem__)) pmBIOSProxy14[];


// BIOS POST Code Strings
extern char const __attribute__((__progmem__))  greetz[];
extern char const __attribute__((__progmem__))  pmPOST1[];
extern char const __attribute__((__progmem__))  pmPOST2[];
extern char const __attribute__((__progmem__))  pmPOST3[];
extern char const __attribute__((__progmem__))  pmPOST4[];
extern char const __attribute__((__progmem__))  pmPOST5[];
extern char const __attribute__((__progmem__))  pmPOST6[];
extern char const __attribute__((__progmem__))  pmPOST7[];
extern char const __attribute__((__progmem__))  pmPOST8[];
extern char const __attribute__((__progmem__))  pmPOST9[];
extern char const __attribute__((__progmem__))  pmPOST0a[];
extern char const __attribute__((__progmem__))  pmPOST0b[];
extern char const __attribute__((__progmem__))  pmPOST0c[];
extern char const __attribute__((__progmem__))  pmPOST0d[];
extern char const __attribute__((__progmem__))  pmPOST0e[];
extern char const __attribute__((__progmem__))  pmPOST0f[];
extern char const __attribute__((__progmem__))  pmPOST10[];
extern char const __attribute__((__progmem__))  pmPOST11[];
extern char const __attribute__((__progmem__))  pmPOST12[];
extern char const __attribute__((__progmem__))  pmPOST13[];
extern char const __attribute__((__progmem__))  pmPOST14[];
extern char const __attribute__((__progmem__))  pmPOST15[];
extern char const __attribute__((__progmem__))  pmPOST16[];
extern char const __attribute__((__progmem__))  pmPOST17[];
extern char const __attribute__((__progmem__))  pmPOST18[];
extern char const __attribute__((__progmem__))  pmPOST19[];
extern char const __attribute__((__progmem__))  pmPOST1a[];
extern char const __attribute__((__progmem__))  pmPOST1b[];
extern char const __attribute__((__progmem__))  pmPOST1c[];
extern char const __attribute__((__progmem__))  pmPOST1d[];
extern char const __attribute__((__progmem__))  pmPOST1e[];
extern char const __attribute__((__progmem__))  pmPOST1f[];

// Menu support




#endif	/* _MUNIX_PROGMEM_H_ */

