#ifndef _MUNIX_BITVECTOR_H_
#define _MUNIX_BITVECTOR_H_
/*******************************************************************************
 ** Name: bitvect.h                                                               **
 ** Description:              **
 **                                                                           **
 ** Open Source Initiative (OSI) Approved License                             **
 **                                                                           **
 ** The contents of this file are subject to the terms of the                 **
 ** Common Development and Distribution License, Version 1.0 only             **
 ** (the "License").  You may not use this file except in compliance          **
 ** with the License.                                                         **
 **                                                                           **
 ** You can find a copy of the license in the license.txt within              **
 ** this distribution or at http://www.munixos.net/licensing.                 **
 ** Software distributed under the License is distributed on an "AS IS"       **
 ** basis, WITHOUT WARRANTY OF ANY KIND, either express or implied.           **
 ** See the License for the specific language governing permissions           **
 ** and limitations under the License.                                        **
 **                                                                           **
 ** When distributing Covered Code, include this CDDL header in each          **
 ** file and include the License file at $HOME/license.txt.                   **
 ** If applicable, add the following below this header, with the indicated    **
 ** fields enclosed by brackets "[]" replaced with your own identifying       **
 ** information: Portions Copyright [yyyy] [name of copyright owner]          **
 **                                                                           **
 **                                                                           **
 ** Copyright (c) 2009-2010  Barry Gian James <bjames@munixos.net>            **
 ** All rights reserved.                                                      **
 **                                                                           **
 ** Ref: $HeadURL: https://DroidEngineer@munix.svn.codeplex.com/svn/trunk/libmunix/bitvect.h $
 ******************************************************************************/
// Portions (C) 2011 OpenHouseware, LLC.
// All Rights Reserved

// $Id: bitvect.h 56635 2011-03-19 15:30:31Z unknown $
// Last Modified $DateTime$ by $Author: unknown $
#define _MUNIX_BITVECTOR_H_ID "$Id: bitvect.h 56635 2011-03-19 15:30:31Z unknown $"

#include "types.h"

#define DEFAULT_BITARRAY_BITS   16

//! class BitArray
//! By default, the maximum number of bits this class can handle is 256 bits
class   BitArray
{
    BitArray();
    BitArray(uint8);
    BitArray(const BitArray&);
    ~BitArray();

    void SetBit(uint8 b) {
        if (b < maxBits && b > 0)
            **bits |= (1<<b);
    }
    uint8 IsSet(uint8 b) {
        return(**bits & (1<<b));
    }
    uint8 Size() const { return maxBits; }
    void Toggle(uint8 b) {
        if (b < maxBits && b > 0)
            **bits ^= (1<<b);
    }

private:
    uint8       maxBits;
    uint8 **    bits;
};

#endif	/* _MUNIX_BITVECTOR_H_ */

