/*******************************************************************************
 ** Name: newint.h                                                            **
 ** Description:              **
 **                                                                           **
 ** Open Source Initiative (OSI) Approved License                             **
 **                                                                           **
 ** The contents of this file are subject to the terms of the                 **
 ** Common Development and Distribution License, Version 1.0 only             **
 ** (the "License").  You may not use this file except in compliance          **
 ** with the License.                                                         **
 **                                                                           **
 ** You can find a copy of the license in the license.txt within              **
 ** this distribution or at http://www.munixos.net/licensing.                 **
 ** Software distributed under the License is distributed on an "AS IS"       **
 ** basis, WITHOUT WARRANTY OF ANY KIND, either express or implied.           **
 ** See the License for the specific language governing permissions           **
 ** and limitations under the License.                                        **
 **                                                                           **
 ** When distributing Covered Code, include this CDDL header in each          **
 ** file and include the License file at $HOME/license.txt.                   **
 ** If applicable, add the following below this header, with the indicated    **
 ** fields enclosed by brackets "[]" replaced with your own identifying       **
 ** information: Portions Copyright [yyyy] [name of copyright owner]          **
 **                                                                           **
 **                                                                           **
 ** Copyright (c) 2009-2010  Barry Gian James <bjames@munixos.net>            **
 ** All rights reserved.                                                      **
 **                                                                           **
 ** Ref: $HeadURL$
 ******************************************************************************/
// Portions (C) 2011 OpenHouseware, LLC.
// All Rights Reserved

// Last Modified $DateTime$ by $Author: bjames $
#define _MUNIX_NEWINT_CPP_ID "$Id: newint.cpp 55956 2011-02-25 05:05:11Z bjames $"

#include "flashaddr.h"

FlashAddr::FlashAddr(const uint32_t i)
{
    a[0] = (i);
    a[1] = (i>>8);
    a[2] = (i>>16);
}

FlashAddr &
FlashAddr::operator += (const FlashAddr & o)
{
    a[0] += o.a[0];
    a[1] += o.a[1];
    a[2] += o.a[2];
    return *this;
}

FlashAddr &
FlashAddr::operator = (const FlashAddr & o)
{
    a[0] = o.a[0];
    a[1] = o.a[1];
    a[2] = o.a[2];
    return *this;
}

const FlashAddr
FlashAddr::operator + (const FlashAddr & o) const
{
    FlashAddr res(A() + o.A());
    return res;
}

const FlashAddr
FlashAddr::operator - (const FlashAddr & o) const
{
    FlashAddr res(A() - o.A());
    return res;
}

const FlashAddr
FlashAddr::operator * (const FlashAddr & o) const
{
    FlashAddr res(A() * o.A());
    return res;
}

uint32_t
FlashAddr::A() const
{
    uint32_t n = (
        (uint32_t)(a[2]*0x10000)
    |   (uint32_t)(a[1]*0x100)
    |   (uint32_t)(a[0])
    );
    return n;
}
