#ifndef _MUNIX_NEWINT_H_
#define	_MUNIX_NEWINT_H_
/*******************************************************************************
 ** Name: flashaddr.h                                                         **
 ** Description:              **
 **                                                                           **
 ** Open Source Initiative (OSI) Approved License                             **
 **                                                                           **
 ** The contents of this file are subject to the terms of the                 **
 ** Common Development and Distribution License, Version 1.0 only             **
 ** (the "License").  You may not use this file except in compliance          **
 ** with the License.                                                         **
 **                                                                           **
 ** You can find a copy of the license in the license.txt within              **
 ** this distribution or at http://www.munixos.net/licensing.                 **
 ** Software distributed under the License is distributed on an "AS IS"       **
 ** basis, WITHOUT WARRANTY OF ANY KIND, either express or implied.           **
 ** See the License for the specific language governing permissions           **
 ** and limitations under the License.                                        **
 **                                                                           **
 ** When distributing Covered Code, include this CDDL header in each          **
 ** file and include the License file at $HOME/license.txt.                   **
 ** If applicable, add the following below this header, with the indicated    **
 ** fields enclosed by brackets "[]" replaced with your own identifying       **
 ** information: Portions Copyright [yyyy] [name of copyright owner]          **
 **                                                                           **
 **                                                                           **
 ** Copyright (c) 2009-2010  Barry Gian James <bjames@munixos.net>            **
 ** All rights reserved.                                                      **
 **                                                                           **
 ** Ref: $HeadURL$
 ******************************************************************************/
// Portions (C) 2011 OpenHouseware, LLC.
// All Rights Reserved

// $Id$
// Last Modified $DateTime$ by $Author: bjames $
#define _MUNIX_NEWINT_H_ID "$Id: newint.h 55956 2011-02-25 05:05:11Z bjames $"
// Last Modified $DateTime$ by $Author: bjames $
#include "types.h"

// Represents a 24-bit flash address
class FlashAddr
{
public:
    FlashAddr() { a[0] = a[1] = a[2] = 0; }
    FlashAddr(const uint32_t);

    FlashAddr &     operator = (const FlashAddr &o);
    FlashAddr &     operator +=(const FlashAddr &o);
    const FlashAddr operator + (const FlashAddr & o) const;
    const FlashAddr operator - (const FlashAddr & o) const;
    const FlashAddr operator * (const FlashAddr & o) const;
    bool            operator ==(const FlashAddr &o) const { return A() == o.A(); }

    uint32_t A() const;
    inline uint8_t A0() { return a[0]; }
    inline uint8_t A1() { return a[1]; }
    inline uint8_t A2() { return a[2]; }
private:
    uint8_t a[3];
};

typedef FlashAddr	uint24_t;
typedef FlashAddr   uint24;
typedef FlashAddr   SRAMAddress;

#endif	/* _MUNIX_NEWINT_H_ */

