#ifndef _MUNIX_MTIME_H
#define	_MUNIX_MTIME_H
/*******************************************************************************
 ** Name: mtime.h                                                             **
 ** Description:              **
 **                                                                           **
 ** Open Source Initiative (OSI) Approved License                             **
 **                                                                           **
 ** The contents of this file are subject to the terms of the                 **
 ** Common Development and Distribution License, Version 1.0 only             **
 ** (the "License").  You may not use this file except in compliance          **
 ** with the License.                                                         **
 **                                                                           **
 ** You can find a copy of the license in the license.txt within              **
 ** this distribution or at http://www.munixos.net/licensing.                 **
 ** Software distributed under the License is distributed on an "AS IS"       **
 ** basis, WITHOUT WARRANTY OF ANY KIND, either express or implied.           **
 ** See the License for the specific language governing permissions           **
 ** and limitations under the License.                                        **
 **                                                                           **
 ** When distributing Covered Code, include this CDDL header in each          **
 ** file and include the License file at $HOME/license.txt.                   **
 ** If applicable, add the following below this header, with the indicated    **
 ** fields enclosed by brackets "[]" replaced with your own identifying       **
 ** information: Portions Copyright [yyyy] [name of copyright owner]          **
 **                                                                           **
 **                                                                           **
 ** Copyright (c) 2009-2010  Barry Gian James.                                **
 ** All rights reserved.                                                      **
 **                                                                           **
 ** Ref: $HeadURL: https://DroidEngineer@munix.svn.codeplex.com/svn/trunk/libmunix/mtime.h $
 ******************************************************************************/
// Portions (C) 2011 OpenHouseware, LLC.
// All Rights Reserved

// $Id: mtime.h 56282 2011-03-05 22:38:01Z unknown $
// Last Modified $DateTime$ by $Author: unknown $
#include "types.h"

struct TimeStruct
{
    TimeStruct() { hour = min = sec = msec = 0; }
    uint8   hour;
    uint8   min;
    uint8   sec;
    uint8   msec;
};

struct DateStruct
{
    DateStruct() { month = day = year = 0; }
    uint8   month;
    uint8   day;
    uint8   year;       // 00 - 99
};
//! @class MTime
//! @brief Encapsulates the functionality to talk to the ATBIOS who
//! proxies for the RTC.  There is a specific I/O address for RTC.
//! NB. The RTC no longer is proxied and talks directly on SPI bus.
class MTime
{
public:
    MTime();
    ~MTime() { }

    // TODO Static methods?
    static TimeStruct  Now();
    static DateStruct  Date();
    static void        TimeStamp(char *);
};

#endif	/* _MUNIX_MTIME_H */

