/*******************************************************************************
 ** Name: newint.cpp                                                          **
 ** Description: Declaration of filesystem paths.                             **
 **                                                                           **
 ** Open Source Initiative (OSI) Approved License                             **
 **                                                                           **
 **  Copyright (c) 2009-2010 Barry "Gian" James  <bjames@munixos.net>         **
 **  All rights reserved.                                                     **
 **                                                                           **
 **  Redistribution and use in source and binary forms, with or without       **
 **  modification, are permitted provided that the following conditions are   **
 **  met:                                                                     **
 **                                                                           **
 **  * Redistributions of source code must retain the above copyright notice, **
 **    this list of conditions and the following disclaimer.                  **
 **  * Redistributions in binary form must reproduce the above copyright      **
 **    notice, this list of conditions and the following disclaimer in the    **
 **    documentation and/or other materials provided with the distribution.   **
 **                                                                           **
 **  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS      **
 ** "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED **
 ** TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A           **
 ** PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT        **
 ** HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,    **
 ** SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED  **
 ** TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR    **
 ** PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF    **
 ** LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING      **
 ** NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS        **
 ** SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.              **
 **                                                                           **
 ******************************************************************************/
#define _MUNIX_NEWINT_CPP_ID "$Id: newint.cpp 55956 2011-02-25 05:05:11Z unknown $"
// Last Modified $DateTime$ by $Author: unknown $

#include "newint.h"

FlashAddr::FlashAddr(const uint32_t i)
{
    a[0] = (i);
    a[1] = (i>>8);
    a[2] = (i>>16);
}

FlashAddr &
FlashAddr::operator += (const FlashAddr & o)
{
    a[0] += o.a[0];
    a[1] += o.a[1];
    a[2] += o.a[2];
    return *this;
}

FlashAddr &
FlashAddr::operator = (const FlashAddr & o)
{
    a[0] = o.a[0];
    a[1] = o.a[1];
    a[2] = o.a[2];
    return *this;
}

const FlashAddr
FlashAddr::operator + (const FlashAddr & o) const
{
    FlashAddr res(A() + o.A());
    return res;
}

const FlashAddr
FlashAddr::operator - (const FlashAddr & o) const
{
    FlashAddr res(A() - o.A());
    return res;
}

const FlashAddr
FlashAddr::operator * (const FlashAddr & o) const
{
    FlashAddr res(A() * o.A());
    return res;
}

uint32_t
FlashAddr::A() const
{
    uint32_t n = (
        (uint32_t)(a[2]*0x10000)
    |   (uint32_t)(a[1]*0x100)
    |   (uint32_t)(a[0])
    );
    return n;
}
