#ifndef _MUNIX_NEWINT_H_
#define	_MUNIX_NEWINT_H_
/******************************************************************************
 ** Name: newint.h                                                    **
 ** Description: Declaration of filesystem paths.                             **
 **                                                                           **
 ** Open Source Initiative (OSI) Approved License                             **
 **                                                                           **
 **  Copyright (c) 2009-2010 Barry "Gian" James  <bjames@munixos.net>         **
 **  All rights reserved.                                                     **
 **                                                                           **
 **  Redistribution and use in source and binary forms, with or without       **
 **  modification, are permitted provided that the following conditions are   **
 **  met:                                                                     **
 **                                                                           **
 **  * Redistributions of source code must retain the above copyright notice, **
 **    this list of conditions and the following disclaimer.                  **
 **  * Redistributions in binary form must reproduce the above copyright      **
 **    notice, this list of conditions and the following disclaimer in the    **
 **    documentation and/or other materials provided with the distribution.   **
 **                                                                           **
 **  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS      **
 ** "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED **
 ** TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A           **
 ** PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT        **
 ** HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,    **
 ** SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED  **
 ** TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR    **
 ** PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF    **
 ** LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING      **
 ** NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS        **
 ** SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.              **
 **                                                                           **
 ******************************************************************************/
#define _MUNIX_NEWINT_H_ID "$Id: newint.h 55956 2011-02-25 05:05:11Z unknown $"
// Last Modified $DateTime$ by $Author: unknown $
#include "common.h"

// Represents a 24-bit flash address
class FlashAddr
{
public:
    FlashAddr() { a[0] = a[1] = a[2] = 0; }
    FlashAddr(const uint32_t);

    FlashAddr &     operator = (const FlashAddr &o);
    FlashAddr &     operator +=(const FlashAddr &o);
    const FlashAddr operator + (const FlashAddr & o) const;
    const FlashAddr operator - (const FlashAddr & o) const;
    const FlashAddr operator * (const FlashAddr & o) const;
    bool            operator ==(const FlashAddr &o) const { return A() == o.A(); }

    uint32_t A() const;
    inline uint8_t A0() { return a[0]; }
    inline uint8_t A1() { return a[1]; }
    inline uint8_t A2() { return a[2]; }
private:
    uint8_t a[3];
};


typedef FlashAddr   uint24;
typedef FlashAddr   SRAMAddr;

#endif	/* _MUNIX_NEWINT_H_ */

