#ifndef _MUNIX_PERIPHERAL_H
#define	_MUNIX_PERIPHERAL_H
/*******************************************************************************
 ** Name: types.h                                                             **
 ** Description:              **
 **                                                                           **
 ** Open Source Initiative (OSI) Approved License                             **
 **                                                                           **
 ** The contents of this file are subject to the terms of the                 **
 ** Common Development and Distribution License, Version 1.0 only             **
 ** (the "License").  You may not use this file except in compliance          **
 ** with the License.                                                         **
 **                                                                           **
 ** You can find a copy of the license in the license.txt within              **
 ** this distribution or at http://www.munixos.net/licensing.                 **
 ** Software distributed under the License is distributed on an "AS IS"       **
 ** basis, WITHOUT WARRANTY OF ANY KIND, either express or implied.           **
 ** See the License for the specific language governing permissions           **
 ** and limitations under the License.                                        **
 **                                                                           **
 ** When distributing Covered Code, include this CDDL header in each          **
 ** file and include the License file at $HOME/license.txt.                   **
 ** If applicable, add the following below this header, with the indicated    **
 ** fields enclosed by brackets "[]" replaced with your own identifying       **
 ** information: Portions Copyright [yyyy] [name of copyright owner]          **
 **                                                                           **
 **                                                                           **
 ** Copyright (c) 2009-2010  Barry Gian James <bjames@munixos.net>            **
 ** All rights reserved.                                                      **
 **                                                                           **
 ** Ref: $HeadURL: https://DroidEngineer@munix.svn.codeplex.com/svn/trunk/libmunix/peripheral.h $
 ******************************************************************************/
// Portions (C) 2011 OpenHouseware, LLC.
// All Rights Reserved

// $Id: peripheral.h 56499 2011-03-14 15:25:03Z unknown $
// Last Modified $DateTime$ by $Author: unknown $
#include "common.h"

enum class PeripheralMode : uint8 { bjames=0x00 };
enum class PeripheralType: uint8 { Timer, ADC_t, AnalogComp, RTC, Watchdog };
//enum class PeripheralType: uint8 { Timer=0x00, ACD=0x01, AnalogComp, RTC, Watchdog };
enum class PeripheralResolution { bits8, bits9, bits10, bits16, bits32 };

class Peripheral
{
public:
    Peripheral(uint8 i, PeripheralType t);
    
    virtual void        PowerUp() = 0;
    virtual void        PowerDown() = 0;
    virtual bool        Setup() = 0;

    inline uint8   ID() const { return id; }
    inline PeripheralType Type() const { return type; }
    inline PeripheralMode Mode() const { return mode; }
    inline PeripheralResolution Resolution() const { return res; }


protected:
    uint8           id;
    PeripheralMode  mode;
    PeripheralType  type;
    PeripheralResolution res;
    
};


#endif	/* _MUNIX_PERIPHERAL_H */

