#ifndef _MUNIX_TYPES_H_
#define _MUNIX_TYPES_H_
/*******************************************************************************
 ** Name: types.h                                                             **
 ** Description:              **
 **                                                                           **
 ** Open Source Initiative (OSI) Approved License                             **
 **                                                                           **
 ** The contents of this file are subject to the terms of the                 **
 ** Common Development and Distribution License, Version 1.0 only             **
 ** (the "License").  You may not use this file except in compliance          **
 ** with the License.                                                         **
 **                                                                           **
 ** You can find a copy of the license in the license.txt within              **
 ** this distribution or at http://www.munixos.net/licensing.                 **
 ** Software distributed under the License is distributed on an "AS IS"       **
 ** basis, WITHOUT WARRANTY OF ANY KIND, either express or implied.           **
 ** See the License for the specific language governing permissions           **
 ** and limitations under the License.                                        **
 **                                                                           **
 ** When distributing Covered Code, include this CDDL header in each          **
 ** file and include the License file at $HOME/license.txt.                   **
 ** If applicable, add the following below this header, with the indicated    **
 ** fields enclosed by brackets "[]" replaced with your own identifying       **
 ** information: Portions Copyright [yyyy] [name of copyright owner]          **
 **                                                                           **
 **                                                                           **
 ** Copyright (c) 2009-2010  Barry Gian James.                                **
 ** All rights reserved.                                                      **
 **                                                                           **
 ** Ref: $HeadURL$
 ******************************************************************************/
// Portions (C) 2011 OpenHouseware, LLC.
// All Rights Reserved

// $Id$
// Last Modified $DateTime$ by $Author: bjames $

#ifdef __cplusplus
extern "C" {
#endif

// AVR-related extensions
typedef unsigned char	uint8_t;
typedef unsigned int	uint16_t;
typedef unsigned long	uint32_t;
typedef unsigned long long int uint64_t;
typedef signed char		int8_t;
typedef int				int16_t;
typedef long			int32_t;
typedef long long int	int64_t;

typedef unsigned char	byte;
typedef unsigned short	word;

typedef uint64_t		uintmax_t;
typedef int64_t			intmax_t;

// POSIX Extensions
typedef unsigned char	uchar_t;
typedef unsigned short	ushort_t;
typedef unsigned int	uint_t;
typedef unsigned long	ulong_t;
typedef char *			caddr_t;
typedef long			daddr_t;

// Typedefs for shorthand
typedef uint8_t		uint8;
typedef uint16_t	uint16;
typedef uint32_t	uint32;
typedef unsigned char uchar;
typedef unsigned long   time_t;
typedef uint8_t		register8;

typedef uint8_t		pid_t;
typedef uint8_t		uid_t;
typedef uint8_t		guid_t;



#ifdef __cplusplus
}
#endif

#endif /* TYPES_H_ */