#ifndef _MUNIX_FACTOR_H
#define	_MUNIX_FACTOR_H
/*******************************************************************************
 ** Name: factor.h                                                             **
 ** Description:              **
 **                                                                           **
 ** Open Source Initiative (OSI) Approved License                             **
 **                                                                           **
 ** The contents of this file are subject to the terms of the                 **
 ** Common Development and Distribution License, Version 1.0 only             **
 ** (the "License").  You may not use this file except in compliance          **
 ** with the License.                                                         **
 **                                                                           **
 ** You can find a copy of the license in the license.txt within              **
 ** this distribution or at http://www.munixos.net/licensing.                 **
 ** Software distributed under the License is distributed on an "AS IS"       **
 ** basis, WITHOUT WARRANTY OF ANY KIND, either express or implied.           **
 ** See the License for the specific language governing permissions           **
 ** and limitations under the License.                                        **
 **                                                                           **
 ** When distributing Covered Code, include this CDDL header in each          **
 ** file and include the License file at $HOME/license.txt.                   **
 ** If applicable, add the following below this header, with the indicated    **
 ** fields enclosed by brackets "[]" replaced with your own identifying       **
 ** information: Portions Copyright [yyyy] [name of copyright owner]          **
 **                                                                           **
 **                                                                           **
 ** Copyright (c) 2009-2010  Barry Gian James.                                **
 ** All rights reserved.                                                      **
 **                                                                           **
 ** Ref: $HeadURL: https://DroidEngineer@munix.svn.codeplex.com/svn/trunk/munixos/factor.h $
 ******************************************************************************/
// Portions (C) 2011 OpenHouseware, LLC.
// All Rights Reserved

// $Id: factor.h 56635 2011-03-19 15:30:31Z unknown $
// Last Modified $DateTime$ by $Author: unknown $
#include "types.h"
#include "path.h"


//class Pathname;
//! @class KFactor
//! @brief A factor of a kernel is a kernel module that can be
//! dynamically loaded and unloaded and runs in normal userland.
//! Provides methods for derived classes on how to be a kernel factor.
class KFactor
{
protected:
    KFactor();
    KFactor(const KFactor & o) = delete;
    virtual ~KFactor();

    virtual bool    Attach();
    virtual bool    Detach();
    virtual uint8   Open();
    virtual uint8   Close();
    virtual bool    Load();
    virtual bool    Unload();
    virtual void *  Dump();

    DirectoryPath &      GetPath() { return path; }

    DirectoryPath        path;

	uint8_t			id;
	static uint8_t	sid;
	static uint8_t	incr() { return ++sid; }



};


#endif	/* _MUNIX_FACTOR_H */

