#ifndef _MUNIX_COREMEM_H_
#define _MUNIX_COREMEM_H_
/*******************************************************************************
 ** Name: kmem.h                                                              **
 ** Description: A set of file system definitions for munixOS.                **
 **                                                                           **
 ** Open Source Initiative (OSI) Approved License                             **
 **                                                                           **
 ** The contents of this file are subject to the terms of the                 **
 ** Common Development and Distribution License, Version 1.0 only             **
 ** (the "License").  You may not use this file except in compliance          **
 ** with the License.                                                         **
 **                                                                           **
 ** You can find a copy of the license in the license.txt within              **
 ** this distribution or at http://www.munixos.net/licensing.                 **
 ** Software distributed under the License is distributed on an "AS IS"       **
 ** basis, WITHOUT WARRANTY OF ANY KIND, either express or implied.           **
 ** See the License for the specific language governing permissions           **
 ** and limitations under the License.                                        **
 **                                                                           **
 ** When distributing Covered Code, include this CDDL header in each          **
 ** file and include the License file at $HOME/license.txt.                   **
 ** If applicable, add the following below this header, with the indicated    **
 ** fields enclosed by brackets "[]" replaced with your own identifying       **
 ** information: Portions Copyright [yyyy] [name of copyright owner]          **
 **                                                                           **
 **                                                                           **
 ** Copyright (c) 2009-2010  Barry Gian James.                                **
 ** All rights reserved.                                                      **
 **                                                                           **
 ** Ref: $HeadURL: https://DroidEngineer@munix.svn.codeplex.com/svn/trunk/munixos/kmem.h $
 ******************************************************************************/
// Portions (C) 2011 OpenHouseware, LLC.

// Last Modified $DateTime: 2010/02/12 01:42:30 $ by $Author: unknown $
// $URL: https://DroidEngineer@munix.svn.codeplex.com/svn/trunk/munixos/kmem.h $
// $Id: kmem.h 56635 2011-03-19 15:30:31Z unknown $
#include <common.h>

#define KMEM_MAX_CACHE      16

//typedef char * SRAMAddress;


// TODO kmem classes for object caching in the kernel
struct KEventList
{

};

class KMemObject
{
protected:
    KMemObject() { refCnt = 0; eventList = NULL; }
    KMemObject(const KMemObject & kmo) = delete;
    virtual ~KMemObject();

    uint8       refCnt;     // number of object references to this object
    KEventList * eventList; // event list
};

class KMemCache
{
public:

};

typedef void (*KMemObjFunc)(void *, size_t);

// Wrappers around the KMemSlab allocator
void *  kmem_alloc(size_t);
void    kmem_free(void *);

// A KMemSlab is a block of contiguous pages from the VM system that will
// be preallocated in a bunch of KMemObjects.
template <class T>
class KMemSlab
{
public:

    KMemCache * Create(char *,size_t,uint8,KMemObjFunc,KMemObjFunc);
    void        Destroy(KMemCache*);
    T *         Allocate(KMemCache *, uint8);
    void        Free(KMemCache *, T*);

};

// TODO
template<class T>
KMemCache *
KMemSlab::Create(char * s, size_t s, uint8_t u, KMemObjFunc f1, KMemObjFunc f2)
{
	KMemCache	obj = new KMemCache();

	return obj;
}

// TODO
template<class T>
void
KMemSlab::Destroy(KMemCache * kmc)
{

}

// TODO
template<class T>
T *
KMemSlab::Allocate(KMemCache * kmc, uint8_t am)
{
	T *	newT = new T();

	return newT;
}

// TODO
template<class T>
void
KMemSlab::Free(KMemCache * kmc, T* t)
{

}



#endif  /* _MUNIX_COREMEM_H_ */
